;
.include "Header.inc"       ;Label und Werte Zuweisungen
.include "Hardware.inc"     ;Hardware Label  Zuweisungen
;
;Programmstart nach RESET  ( Interrupt Vektoren Tabelle )
;
.CSEG                       ;Was ab hier folgt kommt in den FLASH-Speicher
.ORG $0000                  ;Programm beginnt an der FLASH-Adresse 0x0000..
 jmp  _RESET                ;..mit der RESET-Vectortabelle

.include "IRQm6490.inc"     ;Restliche Interrupt Vektortabelle

.ORG INT_VECTORS_SIZE       ;Programmadresse nach den ganzen IRQ-Vektoren
;
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;K Konstanten im Flash 
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;
;.DB 
;
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;I Erstinitialisierungen
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;
_RESET:
 ldi  a,1<<CLKPCE           ;Vorbreitung zum Aendern des Systemtaktes..
 sts  CLKPR,a               ;..auf 8Mhz / 32 bzw. CLKPR = 32..
 ldi  a,1<<CLKPS2|1<<CLKPS0 ;..nun den Systemtakt ( 8 Mhz ) durch 32..
 sts  CLKPR,a               ;..teilen
;
;Stapelzeiger initialisieren (fuer Unterprogramme und / oder Interrupts)
; 
 ldi  a,High(RAMEND)        ;RAMEND, also das Ende vom SRAM, ist in der.. 
 out  SPH,a                 ;..Definitions-datei festgelegt  
 ldi  a,Low (RAMEND)
 out  SPL,a
;
;Variablen initialisieren ( r0-r31 haben unbestimmten Inhalt )
;
; clr  null                  ;Register mit dem Wert Null
;
;Ports Erstkonfiguration
; 
 sbi  PLA_PORT,led.pla      ;PraogrammLaufAnzeige-LED aus ( Vorerst Pullup )
 sbi  PLA_DDR, led.pla      ;PORT-Bit als Ausgang f. PLA-LED ( Jetzt High )
 
 sbi  KEY_PORT,key.bit      ;Pullup f. Taster einschalten

 ser  a                     ;Alle Ports (A-J) als Ausgaenge..
 out  DDRA,a                ;..mit dem Anfangszustand..
 out  DDRB,a                ;..Low..
 out  DDRC,a                ;..
 out  DDRD,a                ;..
 out  DDRE,a                ;..
 out  DDRF,a                ;..
 sbi  DDRG,PG0              ;Nur PortG0 als Ausgang
 sts  DDRH,a                ;..
 sts  DDRJ,a                ;..konfigurieren

 ;out  PORTD,a               ;###################################################
 ;rjmp pc                    ;###################################################

;
; USART Baudrate einstellen
;
 ;ldi  a,#ubrr               ;Fuer UBRRH & UBRRL bei 38400 Baud..
 ;sts  UBRR0H,null           ;..mit 20MHz..
 ;sts  UBRR0L,a              ;..Quarz
;
;USART Format ( 8,N,1 ) ist bereits nach dem Reset voreingestellt, aber um die
;38400 Baud zu erreichen muss U2X0 ( Double the USART Transmission Speed ) ein-
;geschaltet werden. 
;
 ;ldi  a,1<<U2X0             ;Double the USART Transmission Speed..
 ;sts  UCSR0A,a              ;..einstellen, um 38400 Baud mit 0,2% zu erzielen
;
;USART Sendeschieberegisterinterrupt und Sender ( Transmitter ) freigeben
;
 ;ldi  a,1<<TXEN0  ;USART Sendeschieberegisterinterrupt freigeben...1<<TXCIE0|
 ;sts  UCSR0B,a              ;...und USART-Sendeeinheit einschalten
;
;Timer/Counter0 Overflow Interrupt initialisieren
;
 ldi  a,1<<TOIE0            ;Timer0 Overflow Interrupt freigeben...
 sts  TIMSK0,a              ;...
 ldi  a,1<<CS01|1<<CS00     ;Timer0 Vorteiler => 64...
 out  TCCR0A,a              ;...
;
;Timer/Counter2 Overflow Interrupt initialisieren
;
 ;ldi  a,1<<TOIE2            ;Timer2 Overflow Interrupt freigeben...
 ;sts  TIMSK2,a              ;...
 ;ldi  a,0<<CS22|1<<CS21|0<<CS20;Timer0 Vorteiler => 8...
 ;sts  TCCR2B,a              ;...
;
;Timer/Counter2: Fast PWM-Mode ( 7 ) initialisieren, NON-INVERT, 
;ohne Vorteiler. Clear OC2B on Compare Match, set OC2B on TOP. 
;OC2B ist der PWM-Pinn, da OCR2A ja den TOP-Wert enthlt.
;Der OC2A-Pinn ist auf Toggeln eingestellt und hat die halbe Frequenz.
;TOV2-ISR bei TOP.
;
/*
 ldi  a,#fpwm_freq          ;800kHz an OC2B einstellen,..
 sts  OCR2A,a               ;..
 lsr  a                     ;..und Puls,-Pausenverhaeltnis..
 sts  OCR2B,a               ;..50& einstellen.

 ldi  a,NINV0B|1<<WGM21|1<<WGM20;Fast PWM-Mode 7..
 sts  TCCR2A,a              ;..clear OC2B on Compare Match,..
 ldi  a,1<<CS20|1<<WGM22    ;...set OC2B on TOP, ohne Vor-..
 sts  TCCR2B,a              ;..teiler, Timer/Counter2 starten und..
 sbi  PWM2B_DDR,OC2B         ;..PWM-Portpinn als Ausgang  freigeben
;
;ADC Erstwandlung im Free Running Mode. Danach Einzelwandlungen mit ADC-ISR.
;10-Bit, Aref=AVcc, 115200 Hz, digitale Eingangspuffer alle abschalten 
;
 ldi  a,$3F                 ;Alle digitalen Eingangspuffer abschalten..
 sts  DIDR0,a               ;..(PC0-5), um die Leistungsaufnahme zu reduzieren

 ldi  a,1<<REFS0            ;Aref = AVcc.. 
 sts  ADMUX,a               ;..mit 100nF am Aref-Pin

 ;ldi  a,1<<ADEN|1<<ADSC|1<<ADATE|1<<ADIE|1<<ADPS2;ADC Freigeben, Erstwandlung starten,..
 ;sts  ADCSRA,a              ;..Free Running Mode und Vorteiler auf 16 
 
 ldi   a,1<<ADEN|1<<ADSC|1<<ADIF|1<<ADIE|1<<ADPS2;Einzelwandlung mit ADC-ISR..
 sts   ADCSRA,a             ;..starten
*/
sei                        ;Globale Interruptfreigabe im CPU-Statusregister
;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;H Hauptprogrammschleife
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;
_main:
 sec                        ;" Ein-Zustand " 
 clr  a                     ;Definierten " Aus-Zustand " erzeugen
_led_1_8:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 sts  PORTH,a               ;Ein-Zustand einen weiterschalten
 brne _led_1_8              ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_9_16:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 out  PORTC,a               ;Ein-Zustand einen weiterschalten
 brne _led_9_16             ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_17_24:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 out  PORTD,a               ;Ein-Zustand einen weiterschalten
 brne _led_17_24            ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_25_32:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 sts  PORTJ,a               ;Ein-Zustand einen weiterschalten
 brpl _led_25_32            ;7-Bits durch? NEIN -> Naechste LED von diesem Port
 sbi  PORTG,pg0             ;8te Bit setzen bwz. LED-Nr. 32
 ;rcall _taster              ; T E S T ##########################################
 rol  a                     ;Bit 8 ins Carry schieben 
 nop                        ;Timming anpassen
 cbi  PORTG,pg0             ;LED-Nr. 32 wieder ausschalten
 ;rcall _taster              ; T E S T ##########################################
_led_33_40:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 out  PORTA,a               ;Ein-Zustand einen weiterschalten
 brne _led_33_40            ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_41_48:
 rol  a
 out  PORTF,a               ;Ein-Zustand einen weiterschalten
 brne _led_41_48            ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_49_56:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 out  PORTB,a               ;Ein-Zustand einen weiterschalten
 brne _led_49_56            ;8-Bits durch? NEIN -> Naechste LED von diesem Port
_led_57_64:
 ;rcall _taster              ; T E S T ##########################################
 rol  a
 out  PORTE,a               ;Ein-Zustand einen weiterschalten
 brne _led_57_64            ;8-Bits durch? NEIN -> Naechste LED von diesem Port
;
;ProgrammLaufAnzeige (PLA) in Gang halten
;
_idle:
 sbr  flag_reg,1<<pla.flg   ;Programmlaufanzeige-Flag quitieren
 ;sbrc flag_reg,key.wait     ;Tasterbetaetigung noetig? 
 ;rjmp _taster               ;JA  -> Taster wieder abfragen
 ;sbic  PORTE,7              ;Letzte LED angesteuert?..
 rjmp _main                 ;Sprung zum Anfang des Hauptprogramms ( Mainloop )
 ;rjmp _idle 
; 
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;U Beginn der verwendeten Unterprogramme
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;
.include "UP.inc";Unterprogramme
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
.include "ISR.inc";Interrupt Service Routinen
;
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;D Daten im SRAM ablegen
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;
.DSEG
;_adc_werte:
;.BYTE #adc_azhl          ;Anzahl der Eingelesenen ADC-Werte
 
.EXIT                       ;Ende des Quelltextes
