;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
; Headerdatei zu Sparlichtleiste
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;Der ATmega6490P laeuft mit dem internen 1 MHz RC-Oszillator.
;
;FUSES : Extendet $FF, High $99, Low $62.
;
;An einer Leiste die mit 64 1W-LED's bestueckt ist, wird ein Lauflicht in sehr
;schneller Abfolge realisiert. Es leuchtet also jeweils nur eine LED,
;um den Strom niedrig zu halten, da die Leiste Akkubetrieben wird 
;( 4x 1,2V NiMH auf 5,12V mittels XL6009 )
;
;Durch Aufstecken einer 4-poligen Pfostenbuchse die mit einer SMD-LED mit Vor-
;widerstand bestueckt ist, welche an Vcc angeschlossen ist, kann eine 
;ProgrammLaufAnzeige-LED ( PLA-LED ) an Port G4 (Pin29) den Programmlauf 
;anzeigen.
;
;Spaeter sollen die Akkuspannungen gemessen werden und bei Akku-Low erst ein 
;flimmern und bei noch niedriger Spannung der Stripe abgeschaltet werden.
;Jetzt ist jedoch normaler Batteriebetrieb vorhanden.
;
;Die ADC-Werte werden auf 8-Bit beschnitten und ueber die RS232
;mit 38400 Baud ( RS232 spaeter mittels MAX3232 jetzt MAX232 ) an ein 
;Terminalprogramm gesendet ( Hterm ). 
;Bei meinem TTL <-> RS232-Wandler ist es noetig dort 
;DTR & RTS einzuschalten, da ueber eine "Trickschaltung" der MAX232 hierrueber
;mit Spannung versorgt wird, welche vorher zu messen ist, bevor der MAX daran
;angeschlossen wird.
;
;
;Hterm :  1.Byte -> Akku 1 usw.
;
;CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
; Einbinden der Controllerspezifischen Definitionsdatei
;CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
;
.NOLIST                 ;List-Output ausschalten
.INCLUDE "m6490pdef.inc" ;AVR-Definitionsdatei einbinden
.LIST                   ;List-Output wieder einschalten
;
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
; Arbeitsregister umbenennen
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;
;.DEF        = r0   ;
;.DEF        = r1   ;
;.DEF eins_low          = r2   ;Register mit dem Inhalt Eins
;.DEF eins              = r3   ;Register mit dem Inhalt Eins
;.DEF null              = r4   ;Register mit dem Inhalt Null
;.DEF       = r5    ;
;.DEF pixaus_zlr        = r6   ;SK6812 Pixel die aus sind zaehlen
;.DEF pixmusterbit_zlr  = r7   ;SK6812 Pixelmusterbit-Zaehler
;.DEF z_adc_addition    = r8   ;Zaehler f. ADC-Werte addieren
;.DEF ovf2_zlr          = r9   ;Timer2 Overflow-Zaehler
;.DEF      = r10        ;
;.DEF pixmuster         = r11  ;SK6812 Pixelmuster ( LED-Muster )
;.DEF grbw_byte         = r12  ;SK6812 Gruen, Rot, Blau, Weiss-Bytes
;.DEF sk6812_step       = r13  ;Ablaufschritt der SK6812 Ansteuerung
.DEF ovf0_zlr          = r14  ;Timer0 Overflow-Zaehler
.DEF s_sreg            = r15  ;Zum Sichern des Statusregisters ( Nur 1 Takt )

.DEF a                 = r16  ;Allgemeines Arbeitsregister
;.DEF b                 = r17  ;Allgemeines Arbeitsregister
.DEF flag_reg          = r18  ;Allgemeines Flaggenregister;
;.DEF bit_zlr           = r19  ;Zaehler bit schieben
;.DEF sk6812_step           = r20  ;Fuer die Tasterentprellung
;.DEF c_temp            = r21  ;Fuer 16-Bitvergleich ( Compare )
.DEF ia                = r22  ;Interrupt Arbeitsregister ia (Nur in ISR genutzt) )
.DEF key_reg           = r23  ;Tasterentprellregister
;.DEF pixmuster         = r24  ;SK6812 Pixelmuster
;.DEF pixnull_add       = r25  ;+2 Nullen-Addierer  
;.DEF xl                = r26  ;16-Bit-Zaehler fuer..
;.DEF xh                = r27  ;..SK6812 Reset-Zeit
;.DEF yl                = r28  ;16-Bit.. 
;.DEF yh                = r29  ;..Zeitschinder
;.DEF zl                = r30  ;Verwendung als Z-Zeiger, also wie bereits in der..
;.DEF zh                = r31  ;..Definitionsdatei von ATMEL angegeben
;
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
; Konstanten als Symbole
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;
.EQU #ubrr			    = 64	;Wert f. USART Baudrate 38400 Baud

.EQU #ovf0_zlr      = 5         ;Bit 5 -> Bis 32 zaehlen ( Ca. 1 Hz )
;
;ADC
;
.EQU #adc_azhl	    = 10		;Anzahl der eingelesenen ADC-Werte


.EQU P_PERIODE      = ~(1<<MUX3|1<<MUX2|1<<MUX1|1<<MUX0);Poti Periodendauer ADC0
.EQU P_PULS         = MUX1  ;Poti Pulsdauer ADC1
;
;Bitbezeichner fuer das allgemeine Flaggenregister flag_reg
;
;.equ			= 0	;
;.equ			= 1	;
;.equ  tc2.ovf       = 2	;Timer2 Pseudo Overflow-Flag
.equ  key.wait      = 3 ;Es wird auf eine Tasterbetaetigung benoetigt
.equ  pla.flg		= 4	;Programmlaufanzeige-Quitierung
;.equ  mwert.rdy	 	= 5	;ADC-Mittelwertsbildung fertig
;.equ		    = 6	;
;.equ		    = 7	; 
;
;Bitbezeichner fuer das Tasterentprellregister key_reg
;
;.equ			= 0	;Taster..
;.equ			= 1	;..Prellzaehler
.equ  key.unactuated	= 2	;Taster entprellt unbetaetigt
.equ  key.actuated		= 3	;Taster entprellt betaetigt
;.equ			= 4	;
;.equ	        = 5	;
;.equ	        = 6	; 
;.equ		    = 7	; 